///home/berryj/link/bin/genMethods "-g" "-t" "Sequence<Vertex*>" "-h" "Collection" "-c" "Vertex*" "-I" "LINK/graph/Vertex.h" "-I" "LINK/stkWrapper/SetFuncsWrapper.h" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Sequence.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/SetFuncsWrapper.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Sequence.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Sequence<Vertex*> _Sequence_Vertex__;
typedef Collection<Sequence<Vertex*> > _Collection_Sequence_Vertex___;

#define _Collection_Sequence_Vertex___DATA(x) ((Collection<Sequence<Vertex*> >*) (EXTDATA(x)))
#define _Collection_Sequence_Vertex___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Sequence<Vertex*> > >::type))
#define _Collection_Sequence_Vertex___ISNT_DATA(x) (!_Collection_Sequence_Vertex___IS_DATA(x))

#define _Collection_Sequence_Vertex___CXX_DATA(x) (*(Collection<Sequence<Vertex*> >*) (EXTDATA(VAL(x))))
#define _Collection_Sequence_Vertex___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Sequence<Vertex*> > >::type))
#define _Collection_Sequence_Vertex___CXX_ISNT_DATA(x) (!_Collection_Sequence_Vertex___CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Sequence_Vertex___()
{
	Wrapper<_Collection_Sequence_Vertex___>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Sequence_Vertex___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Sequence_Vertex__>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Sequence_Vertex__>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Sequence_Vertex__>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Sequence_Vertex___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Sequence_Vertex___Methods(void);

PRIMITIVE STk_init_methods__Collection_Sequence_Vertex___()
{
	STk_add_new_cpp_primitive("collection-Sequence-Vertex?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collectionP);
	STk_add_new_cpp_primitive("mset-Sequence-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::buildMSet);
	STk_add_new_cpp_primitive("set-Sequence-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::buildSet);
	STk_add_new_cpp_primitive("sequence-Sequence-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Sequence-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Sequence-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Sequence-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Sequence-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("set-Sequence-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Sequence-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Sequence-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("set-Sequence-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Sequence-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Sequence_Vertex__>::collection2STkString);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-cartesian-product", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::cartesianProduct);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-choose", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::choose);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-power-set", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::powerSet);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-permutations", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::permutations);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-permutation", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::permutation);
	STk_add_new_cpp_primitive("Collection-Sequence-Vertex-permutation-rank", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Vertex* >::rank);

	addListMethod("mset-Sequence-Vertex",
		"mset-Sequence-Vertex1", LINK_NEW);
	addListMethod("set-Sequence-Vertex",
		"set-Sequence-Vertex1", LINK_NEW);
	addListMethod("sequence-Sequence-Vertex",
		"sequence-Sequence-Vertex1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Sequence_Vertex__ >::name, 
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"<integer>",
		"Collection-Sequence-Vertex-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Sequence_Vertex__ >::name, 
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Sequence_Vertex__ >::name, 
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Sequence_Vertex__ >::name, 
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Sequence_Vertex___ >::name, 
		"Collection-Sequence-Vertex--", LINK_OVL);
	addTwoArgMethod("cartesian-product",
		Wrapper<_Sequence_Vertex__ >::name, 
		Wrapper<_Sequence_Vertex__ >::name, 
		"Collection-Sequence-Vertex-cartesian-product", LINK_NEW);
	addTwoArgMethod("choose",
		Wrapper<_Sequence_Vertex__ >::name, 
		"<integer>",
		"Collection-Sequence-Vertex-choose", LINK_NEW);
	addOneArgMethod("power-set",
		Wrapper<_Sequence_Vertex__ >::name, 
		"Collection-Sequence-Vertex-power-set", LINK_NEW);
	addOneArgMethod("permutations",
		Wrapper<_Sequence_Vertex__ >::name, 
		"Collection-Sequence-Vertex-permutations", LINK_NEW);
	addTwoArgMethod("permutation",
		Wrapper<_Sequence_Vertex__ >::name, 
		"<integer>",
		"Collection-Sequence-Vertex-permutation", LINK_NEW);
	addOneArgMethod("permutation-rank",
		Wrapper<_Sequence_Vertex__ >::name, 
		"Collection-Sequence-Vertex-permutation-rank", LINK_NEW);
	genExtra_Collection_Sequence_Vertex___Methods();
	return UNDEFINED;
}
